#include <math.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>



void read_data(void);

void SRS_sum(void);

void SRS_ave(void);

void freq_check(void);

void ktable_values(void);

void find_limits(void);


#define NUM 10000



#define FILE_NUM 500





double SRS[NUM];

double SRS2[NUM];



double sd[NUM];



double ktol;



double ktable[50];



double limit;



long i,j,jmax,k;



long imax;



long num[FILE_NUM];



int idist;



double amp[FILE_NUM][NUM];

double freq[FILE_NUM][NUM];

double df[FILE_NUM];



double fmin,fmax;



double ff,aa;





FILE *pFile[5];

char filename[5][25];




void main()
{

    



	for(i=0; i< NUM; i++)

	{

          SRS[i]=0.;

         SRS2[i]=0.;

	}



	printf("\n\n   SRS_9550.cpp   ver 1.0  August 11, 2005  \n");

	printf("\n   by Tom Irvine   ");

	printf("\n   Email: tomirvine@aol.com  \n"); 





	printf("\n   This program calculates the P95/50 level of a number of SRS functions. \n");

    printf("\n   P95/50 level is the 95th percentile value with a 50 percent confidence. \n");





	  printf("\n   The names of the individual SRS files must be in a file called files.in. ");

	  printf("\n   At least two SRS input files are required. \n");



	  printf("\n   Each SRS file must have the same number of lines and the same \n   frequency step. \n");	





	printf("\n\n   Press any key to continue.\n\n");

	getch();





	strcpy(filename[0],"files.in");

    pFile[0]=fopen(filename[0],"rb");





   if(pFile[0] == NULL )

   {

      printf(" Failed to open file: %s \n", filename[0]);

      fclose(pFile[0]);

      exit(1);

   }





	strcpy(filename[2],"file_check.txt");

    pFile[2]=fopen(filename[2],"w");



	

	strcpy(filename[3],"SRS_9550.txt");

    pFile[3]=fopen(filename[3],"w");







	printf("\n\n Select distribution ");

	printf("\n  1=normal  2=lognormal \n");



	scanf("%d",&idist);







    find_limits();



	read_data();





	if( imax == 1 )

	{



        printf("\n Error: at least two SRS input files are required. \n");



	    printf("\n\n Press any key to exit.");

	

	    getch();



		exit(1);

	}



	rewind(pFile[0]);



    freq_check();



	SRS_sum();



	SRS_ave();






	printf("\n\n Calculation complete. \n\n");





	printf("\n\n   Please open %s to check file status. \n",filename[2]);



    printf("\n   Each SRS file must have the same number of lines and the same \n   frequency step. \n");	



	

	printf("\n   The output file is: %s \n",filename[3]);

	

	printf("\n\n Press any key to exit.");
	



	getch();


}

void find_limits(void)

{

	fmin=0.;

	fmax=1.0e+99;



	i=0;



	while(1)

	{

   

        if( fscanf(pFile[0],"%s",filename[1]) <= 0 ){break;}   

        

		pFile[1]=fopen(filename[1],"rb");





		if(pFile[1] == NULL )

		{

			printf("  Failed to open file: %s \n", filename[1]);

	

			printf("\n\n  Press any key to exit. \n");

			getch();



			exit(1);

		}



		j=0;

	

        while(1)

		{

            if( fscanf(pFile[1],"%lf %lf",&ff,&aa ) <= 0 ){break;}



			if( j == 0 )

			{ 

				if(ff > fmin ){ fmin = ff;}

			}

            j++;



			if(j==NUM){break;}



        }

		fclose(pFile[1]);



        if(ff<fmax){fmax=ff;}



		i++;

	}

    rewind(pFile[0]);



	printf("\n\n  fmin= %10.1lf Hz \n  fmax= %10.1lf Hz  \n\n",fmin,fmax);





}

void read_data(void)

{

	i=0;





    while(1)

	{

   

        if( fscanf(pFile[0],"%s",filename[1]) <= 0 ){break;}   

        

		pFile[1]=fopen(filename[1],"rb");





		if(pFile[1] == NULL )

		{

			printf("  Failed to open file: %s \n", filename[1]);

	

			printf("\n\n  Press any key to exit. \n");

			getch();



			exit(1);

		}





		j=0;

	

        while(1)

		{

            if( fscanf(pFile[1],"%lf %lf",&ff,&aa ) <= 0 ){break;}





			if(idist==2)

			{

              

				if(aa <= 0 )

				{

					printf("\n Error: all values must be > 0 \n");



					exit(1);

				}



				aa=log10(aa);

			}







            if(ff >= fmin && ff<=fmax)

			{



				freq[i][j] = ff;

				amp[i][j] = aa;





				df[i]=( freq[i][j]-freq[i][0] );



//			printf("  %ld  %ld    %12.4g \n",i,j,df[i] );



				j++;

			}



			if( j == NUM ){ break; }

        }



		num[i]=j;

         df[i]/=double(j);







//		 printf(" %ld  %12.4g  \n",j,df[i] );





		if( j > jmax){jmax=j;}



		fclose(pFile[1]);



		i++;

	}

//	getch();



	limit=df[0]/5.;

	imax=i;

}



void freq_check(void)

{





	fprintf(pFile[2],"\n  Filename     f1(Hz)      df(Hz)   number of points \n\n");	

	printf("\n  Filename         df(Hz)   number of points \n\n");	





	for(i=0; i<imax; i++)

	{

		

        fscanf(pFile[0],"%s",filename[1]);



		fprintf(pFile[2],"   %s    %8.3lf  %8.3lf       %ld  \n",filename[1],freq[i][0],df[i],num[i]);

		

		printf("   %s      %8.3lf       %ld  \n",filename[1],df[i],num[i]);

		

	}





    fclose(pFile[2]);





	for(k=0; k<jmax; k++)

	{

	

		for(i=0; i<imax-1; i++)

		{



			for(j=i+1; j<imax; j++)

			{



				if(  fabs( freq[i][k]-freq[j][k] ) > limit )

				{

					printf("\n  i=%ld j=%ld k=%ld \n",i,j,k);



					printf(" %12.5g \n",freq[i][k]);



					printf(" %12.5g \n",freq[j][k]);

 

	                printf(" %12.5g \n",fabs(freq[i][k]-freq[j][k]) );

 

					printf("\n Frequency synchronization error \n");



	                printf("\n\n   Please open %s to check file status. \n",filename[2]);





					printf("\n\n Press any key to exit.");

	

					getch();



					exit(1);

				}



            }

		}

	}

}



void SRS_sum(void)

{



	for(i=0; i<imax; i++)

	{	

		for(j=0; j< jmax; j++)

		{



			SRS[j]+=amp[i][j];



		}

	}

}

void SRS_ave(void)

{

	double level;



	double mean[NUM];





    ktable_values();





	if( imax >= 2 && imax <= 45 )

	{



		ktol = ktable[imax];

	}

	if( imax > 45 )

	{

		ktol = 1.64485; 

	}





	printf("\n\n  %ld files \n",imax);

	printf("\n\n  ktol = %5.4g \n",ktol);



	for(j=0; j< jmax; j++)

	{

		mean[j]=SRS[j]/double(imax);

	}





	for(i=0; i<imax; i++)

	{	

		for(j=0; j< jmax; j++)

		{



			sd[j]+= pow( ( amp[i][j] - mean[j] ) ,2.);



		}



	}



	for(j=0; j< jmax; j++)

	{



		sd[j] = sd[j]/( double(imax)  -1. );



		sd[j] = sqrt( fabs( sd[j] ) );





		level = mean[j] + ktol * sd[j]; 



		if(idist==2)

		{

			level=pow(10,level);

		}



        fprintf(pFile[3]," %12.4g %12.4g \n",freq[0][j],level );



	}





    



}

void ktable_values(void)

{



	ktable[2]= 2.339;

	ktable[3]= 1.939;

	ktable[4]= 1.830;

	ktable[5]= 1.779;

	ktable[6]= 1.750;

	ktable[7]= 1.732;

	ktable[8]= 1.719;

	ktable[9]= 1.709;

	ktable[10]= 1.702;

	ktable[11]= 1.696;

	ktable[12]= 1.691;

	ktable[13]= 1.687;

	ktable[14]= 1.684;

	ktable[15]= 1.681;

	ktable[16]= 1.678;

	ktable[17]= 1.676;

	ktable[18]= 1.674;

	ktable[19]= 1,673;

	ktable[20]= 1.671;

	ktable[21]= 1.670;

	ktable[22]= 1.669;

	ktable[23]= 1.668;

	ktable[24]= 1.667;

	ktable[25]= 1.666;

	ktable[26]= 1.665;

	ktable[27]= 1.664;

	ktable[28]= 1.663;

	ktable[29]= 1.662;

	ktable[30]= 1.662;

	ktable[31]= 1.662;

	ktable[32]= 1.661;

	ktable[33]= 1.661;

	ktable[34]= 1.660;

	ktable[35]= 1.659;

	ktable[36]= 1.659;

	ktable[37]= 1.659;

	ktable[38]= 1.659;

	ktable[39]= 1.659;

	ktable[40]= 1.658;

	ktable[41]= 1.658;

	ktable[42]= 1.657;

	ktable[43]= 1.657;

	ktable[44]= 1.656;

	ktable[45]= 1.656;



}

