
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>


#define NUM 200000



#define NFILES 40





void zero(void);

void read_data(void);



double p,sum[NUM];



const double max=32767.;



long i,j,k,m;



long klimit;



long length[NFILES];



long delay[NFILES];



double dt;



double t[NFILES][NUM],a[NFILES][NUM];



double GRMS_MAX=0.;



double GRMS;



double scale[NFILES];



double ms;



double shift;



long max_length=0;



long ntrials;



long inversion;




char filename[10][FILENAME_MAX];

FILE *pFile[10];




void main()
{



	printf("\n composite_shock.cpp   version 1.2   March 10, 2006\n");

	printf("\n By Tom Irvine   Email:  tomirvine@aol.com \n");



	printf("\n This program adds shock time histories to form a composite ");

	printf("\n time history. The time histories are inverted and shifted ");

	printf("\n as necessary to maximize the RMS value. \n");



	printf("\n The names of the individual files must be in a file called: \n files.in. \n");



	printf("\n Each time history must have the same sample rate.   ");

	printf("\n Synchronization is not required, however.         \n");




    zero();



	read_data();



	klimit=k;



	dt=(t[0][4]-t[0][0])/4;



	printf("\n dt=%8.4g \n",dt);



	printf("\n Enter maximum time shift \n");

	scanf("%lf",&shift);



	printf("\n Enter number of trials \n");

	scanf("%ld",&ntrials);



	printf("\n Allow inversion? ");

    printf("\n 1=yes 2=no \n");

	scanf("%ld",&inversion);

    

    double nshift=(shift/dt);





	for(m=0;m<ntrials;m++)

	{



		for(k=0;k<klimit;k++)

		{



			scale[k]=1;



			if(inversion==1)

			{



				if(m>long(ntrials/5.) )

				{

					p=rand()/max;

			

					if(p<0.5)

					{

						scale[k]=-1.;

					}

				}

			}



			delay[k]=long( nshift*rand()/max );



			if(m<1)

			{

				delay[k]=0;

			}



		}



		ms=0.;



		for(i=0;i<max_length;i++)

		{

			sum[i]=0.;



			for(k=0;k<klimit;k++)

			{

				sum[i]+=a[k][i+delay[k]]*scale[k];

			}



			ms+=pow(sum[i],2.);



		}



		GRMS=sqrt(ms/max_length);



//		printf(" %ld %10.5g %10.5g\n",m,GRMS,GRMS_MAX);



		if(GRMS>GRMS_MAX)

		{

			GRMS_MAX=GRMS;



			printf("\n %ld %10.5g\n",m,GRMS_MAX);

			

			for(k=0;k<klimit;k++)

			{

				printf(" %4.1f  %ld \n",scale[k],delay[k]);

			}



	

			pFile[2]=fopen(filename[2],"w");		

			

			for(i=0;i<max_length;i++)

			{

				fprintf(pFile[2]," %10.5e  %10.5e \n",dt*i,sum[i]);

			}

			fclose(pFile[2]);

			

		}





	}



	printf("\n The output time history is: %s \n",filename[2]);



	printf("\n\n Calculation complete. \n Press any key to exit.");

	getch();



}

void read_data()

{



	printf("\n ref 3 \n");



	strcpy(filename[0],"files.in");

	strcpy(filename[2],"composite.out");



	pFile[0]=fopen(filename[0],"rb");



	

	for( i=0; i<=0; ++i)

    {

       if(pFile[i] == NULL )

       {

			printf(" Failed to open file: %s \n", filename[i]);

			exit(1);

       }

       else

       {

			printf(" File: %s opened. \n", filename[i]);

       }

    }





	k=0;



    while(1)

	{

   

        if( fscanf(pFile[0],"%s",filename[1]) <= 0 ){break;}   

        



		pFile[1]=fopen(filename[1],"rb");





		if(pFile[1] == NULL )

		{

			printf("  Failed to open file: %s \n", filename[1]);

	

			printf("\n\n  Press any key to exit. \n");

			getch();



			exit(1);

		}





		j=0;

	

        while(1)

		{

            if( fscanf(pFile[1],"%lf %lf",&t[k][j],&a[k][j] ) <= 0 ){break;}



			j++;



			if(j==NUM)

			{

				printf("\n error 2 \n");

				exit(1);

			}



        }

		fclose(pFile[1]);



		length[k]=j-1;



		if(length[k]>max_length)

		{

			max_length=length[k];

		}



		k++;



		if(k==NFILES)

		{

			printf("\n error 1 \n");



			printf("\n maximum file limit exceeded. \n");



			exit(1);

		}



	}

}

void zero(void)

{

//	printf("\n ref 1b \n");



	for(i=0;i<NFILES;i++)

	{

		for(j=0;j<NUM;j++)

		{

			t[i][j]=0.;

			a[i][j]=0.;

		}

	}

//	printf("\n ref 1c \n");

}
