#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>

#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>

#define MAX 200000
#define MAXP 10000


void sf(void);
void elapsed();
void srmany(void);


void header(void);

time_t ltime;
time_t ltimen;

long i,ie,ik,j,k,kk,l,n,nt,num,num1,num2,nwave;



double fla,fua;

double aaa,am,ave,sd,sq;


double arg;

double error,errormax;

double duration;

double x1,x2,x4;


double x1r[MAXP];
double x2r[MAXP];
double x4r[MAXP];
long x3r[MAXP];

long x3;

double t1,t2;



double t[MAX],residual[MAX],amp[MAX];
double f[MAXP],p[MAXP];



long nhs[MAXP];



double freq[MAXP],delay[MAXP];



double vlast[MAXP];



double asd[MAX];



double fl,fu;



double pl,pu;
double y;

double tol,tstart,tt;

double sr,ffmax;

long drate;

const double pi=atan2(0.,-1);
const double tp=2.*pi;

const double tpi=tp;

const double max=32767.;

const long numBytes=300;
char string[numBytes];

FILE *pFile[20];
char filename[8][FILENAME_MAX];


int main()
{
		time( &ltime );
		tstart=double(ltime);

//		strcpy(filename[0],"sf.in");

		printf("\n wavelet_reconstruct.cpp   version 1.7   July 7, 2010\n");
		printf("\n By Tom Irvine   Email:  tomirvine@aol.com \n");

		printf("\n This program synthesizes a wavelet series to approximate \n");

		printf("\n an input time history. \n");

		printf("\n The input file must be: time(sec) and amplitude(units) ");
		printf("\n Format is free, but no header lines allowed.\n");
		printf("\n Please enter the input filename. \n");

		scanf("%s", filename[1]);

		strcpy(filename[2],"wavelet_table.out");

		strcpy(filename[3],"temp.out");



		printf("\n\n");

		for(i=1; i<=3; i++)
		{
			if(i>=2)
			{
				pFile[i]=fopen(filename[i],"w");
			}
			else
			{
				pFile[i]=fopen(filename[i],"rb");
			}

			if(pFile[i] == NULL )
			{
				printf("\n Failed to open file: %s \n", filename[i]);
				fclose(pFile[i]);
				exit(1);
			}
			else
			{
				printf(" File: %s opened. \n", filename[i]);
			}
		}
		printf("\n");

		ik=0;
       
//		fprintf(pFile[2],"%ld",ik);
	


		for(i=0;i<MAXP;i++)

        {
			x1r[i]=0.;
			x2r[i]=0.;

			x3r[i]=0;

			x4r[i]=0.;

		}

		printf("\n\n Enter the number of trials per frequency. \n");
		scanf("%ld",&nt);
		
		long nfr;

		printf("\n\n Enter the number of frequencies. \n");
		scanf("%ld",&nfr);


      
		ffmax=0.;


		header();
       
		for(i=1; i<MAX; i++)
		{
//			if( fscanf(pFile[1],"%lf %lf",&t[i],&residual[i]) <=0 ){break;}
			
   	            if(fgets(string,numBytes,pFile[1] )<=0){break;} 			
			
                if(strrchr(string,',' ) != NULL )
			    {
				   sscanf(string,"%lf, %lf", &t[i],&residual[i] );
			    }
			    else
			    {
				   sscanf(string,"%lf %lf", &t[i],&residual[i] );
			    }  	
		}




		num2=i-1;
		printf("\n number of input file points = %ld",num2);


		duration=t[num2]-t[1];


        sr=duration/(num2-1);
		sr=1./sr;

		drate=long(sr/(ffmax*16.));

		if(drate <2){drate=1;}
		if(drate > 10){drate=10;}

		printf("\n sample rate = %10.4g  dr= %ld \n",sr,drate);

        fl=3./duration;

		fu=sr/5.;



		fla=fl;

		fua=fu;


        double tph=tp/2.;
       
		for(ie=1; ie<=nfr; ie++)
		{

			printf("\n frequency case %ld ",ie);

			sf();

			elapsed();


			for(i=1; i<=n; i++)
			{

				tt=t[i];

				t1=x4r[ie] + t[1];

				t2=t1 + tph*x3r[ie]/x2r[ie];

				y=0.;


				if( tt>= t1 && tt <= t2)
				{

					arg=x2r[ie]*(tt-t1);  

					y=x1r[ie]*sin(arg/double(x3r[ie]))*sin(arg);			

				}

				residual[i]-=y;

				ave+=residual[i];

				sq+=pow(residual[i],2.);	

			} 

			ave/=double(num2);


			sd=sqrt( (sq/num2) -pow(ave,2.));

			printf("\n ave=%12.4g  sd=%12.4g \n\n",ave,sd);

			 
		}
	   	

		for(i=1; i<=3; i++)
		{
			fclose(pFile[i]);
		}

	    srmany();

	printf("\n\n");
}

void sf(void)
{
		ave=0.;
		sq=0.;

		long jki=0;

		long jflag=1;



		for(i=1; i<=num2; i++)
		{
          ave+=residual[i];
          sq+=pow(residual[i],2.);



		  asd[i]=pow(residual[i],2.);
		}

		ave/=double(num2);
	   
		sd=sqrt( (sq/num2) -pow(ave,2.));

		printf("\n ave=%12.4g  sd=%12.4g",ave,sd);

		am=2.*sd;
		n=num2;
	       
 //       printf("\n n=%ld  nt=%ld  num2=%ld \n",n,nt,num2);

		errormax=1.0e+53;



		double x33;

		printf("\n\n  Trial     Error      Amplitude   Freq(Hz)   NHS    delay(sec) \n");


		if(j==1)
		{

			fl=3/duration;

			fu=sr/5.;

		}


		double ran1,ran2,ran3;

		int itype;


		for(j=1; j<=nt; j++)
		{

			ran1=rand()/max;

			ran2=rand()/max;	

			ran3=rand()/max;

				

			x1=rand()/max;
			x2=rand()/max;
			x33=rand()/max;
			x4=rand()/max;



			x1=2.*am*(x1-0.5);		// amplitude


			x2=((fu-fl)*x2+fl)*tp;	// freq


			x3= 3+(2*long(x33*30));	// nhs


			x4*=0.8*duration;		// delay



			itype=1;

			if(ran1>0.4 && ran1<=0.5)
			{

				x2=x2r[ie]*(0.99+0.02*rand()/max);

				x4=x4r[ie]*(0.99+0.02*rand()/max);



				if(ran2<=0.25)
				{
					x3=x3r[ie]-4;
				}
				if(ran2>0.25 && ran2<=0.5)
				{
					x3=x3r[ie]-2;
				}

				if(ran2>0.50 && ran2<=0.75)
				{
					x3=x3r[ie]+2;
				}

				if(ran2>0.75 && ran2<=1.0)
				{
					x3=x3r[ie]+4;
				}


				x1=x1r[ie]*(0.95+0.10*rand()/max);


				if(ran3>0.5)
				{

					x1*=-1;

				}


				if(x3<3){x3=3;}


				itype=2;  // mainly NHS


			}			

			if(ran1>0.5 && ran1<=0.6)  
			{

				x1=x1r[ie]*(0.98+0.04*rand()/max);

				x2=x2r[ie];

				x3=x3r[ie];

				x4=x4r[ie];



				itype=3; // amp  

			}

			if(ran1>0.6 && ran1<=0.7)
			{

				x1=x1r[ie];

				x2=x2r[ie]*(0.99+0.02*rand()/max);	

				x3=x3r[ie];

				x4=x4r[ie];

				

				itype=4;  // freq

			}

			if(ran1>0.8 && ran1<=0.9)
			{

				x1=x1r[ie];

				x2=x2r[ie];

				x3=x3r[ie];

				x4=x4r[ie]*(0.99+0.02*rand()/max);



				itype=5;  // delay

			}

			if(ran1>0.9 && ran1<=1.)
			{

				x1=x1r[ie]*(0.999+0.002*rand()/max);

				x2=x2r[ie]*(0.999+0.002*rand()/max);

				x3=x3r[ie];

				x4=x4r[ie]*(0.999+0.002*rand()/max);



				itype=6;  // all but NHS

			}



			while(1)
			{

				if( tp*x3/(2.*x2) + x4 < duration )
				{
					break;
				}
				else
				{

					x3-=2;

					if(x3==1)
					{

						x1=0;

						x2=fu*tp;

						x3=3;

						x4=0;

						break;

					}

				}

			}
	
			if(j==1 || x3 < 3)
			{

				x1=0.;

				x2=fu*tp;

				x3=3;

				x4=0.;

			}

			error=0.;

			t1=x4 + t[1];

			t2=t1 + tp*x3/(2.*x2);

			if(j==1){x1=0.;}


			for(i=1; i<=n; i++)
			{

				tt=t[i];

				y=0.;

				if( tt>= t1 && tt <= t2)
				{

					arg=x2*(tt-t1);  

					y=x1*sin(arg/double(x3))*sin(arg);

					error+=pow((residual[i]-y),2.);

				}
				else
				{
					error+=asd[i];
				}
			} 
			error=sqrt(error);



//			printf("\n %ld  %11.4e  %9.4lf %9.4lf  %ld  %9.4lf ",j,error,x1,x2/tp,x3,x4);

//			getch();


			if(error<errormax)
			{

				if(j>3)
				{
					jflag=2;
				}

				jki=0;


				x1r[ie]=x1;
				x2r[ie]=x2;
				x3r[ie]=x3;

				x4r[ie]=x4;

				printf("\n %ld  %11.4e  %9.4lf %9.4lf  %ld  %9.4lf %d",j,error,x1,x2/tp,x3,x4,itype);

				errormax=error;

//				printf("\n x3r[%ld]=%ld \n",ie,x3r[ie]);


			}
       }


	  fprintf(pFile[2],"\n %ld  %9.4f %10.4f %ld %14.7e",ie,x2r[ie]/tpi,x1r[ie],x3r[ie],x4r[ie]);


}
void elapsed()
{

	double tnow;
   
	time( &ltimen );

	tnow=double(ltimen);

	double ttt=tnow-tstart;
				
	printf("\n\n elapsed time = %12.5g sec   time per trial = %12.5g\n",ttt,ttt/ie);
}



void srmany(void)
{
		strcpy(filename[0],"wavelet_table.out");
		strcpy(filename[2],"error.out");
		strcpy(filename[3],"accel.out");

	    strcpy(filename[4],"velox.out");

	    strcpy(filename[5],"disp.out");





//		long nhs[MAX];

		printf("\n\n");

		for(i=0; i<=5; i++)
		{
			if(i>=2)
			{
				pFile[i]=fopen(filename[i],"w");
			}
			else
			{
				pFile[i]=fopen(filename[i],"rb");
			}

			if(pFile[i] == NULL )
			{
				printf("\n Failed to open file: %s \n", filename[i]);
				fclose(pFile[i]);
				exit(1);
			}
			else
			{
//				printf(" File: %s opened. \n", filename[i]);
			}
		}
		printf("\n");

		kk=0;
      
//		fscanf(pFile[0],"%ld",&ik);

		for(i=1; i<ie; i++)
		{
//			if(fscanf(pFile[0],"%lf %lf %ld %lf",&residual[i],&freq[i],&nhs[i],&delay[i]) <=0 ){break;}

//           printf("\n amp=%10.4lf   freq=%10.3lf Hz   nhs=%ld   delay=%10.4lf",residual[i],freq[i],nhs[i],delay[i]);


//			freq[i]*=tpi;



			printf("\n amp=%10.4lf   freq=%10.3lf Hz   nhs=%ld   delay=%10.4lf",x1r[i],x2r[i]/tp,x3r[i],x4r[i]);





//		residual[i]*=-1.;
		}
		num=i-1;

		fclose(pFile[0]);


		header();
		
		

		

//		printf("\n\n reference 1 ");
		for(j=1; j<MAX; j++)
		{
				t[j]=0.;
				amp[j]=0.;

//				if(fscanf(pFile[1],"%lf %lf",&t[j],&amp[j]) <=0 ){break;}				
	
   	            if(fgets(string,numBytes,pFile[1] )<=0){break;} 
   	            
 			    if(strrchr(string,',' ) != NULL )
			    {
				   sscanf(string,"%lf, %lf", &t[j],&amp[j] );
			    }
			    else
			    {
				   sscanf(string,"%lf %lf", &t[j],&amp[j] );
			    }  	            
    			
				kk++;
		}
		long limit=kk;	
        
		fclose(pFile[1]);

//		printf("\n reference 2 ");

		printf("\n\n num=%ld  limit=%ld \n",num,limit);


        double w,v,vvv,v1,v2;

		double d,ddd,d1,d2;



		double aa,bb;

		double te;



		double alpha1,alpha2;



		double tf=0.;


		for(i=0;i<MAXP;i++)
		{
			vlast[i]=0.;
		}
		
		double alpha;
		double beta;
		double apb;
		double amb;

		for(k=1; k<=limit; k++)
		{

				aaa=0.;
				vvv=0.;
				ddd=0.;

				tt=t[k];
				
              
				for(j=1; j<ie; j++)
				{

                    w=0.;
					v=0.;
					d=0.;

					v1=0.;
					v2=0.;

					d1=0.;
					d2=0.;


					t1=x4r[j]+t[1];

					t2=tp*x3r[j]/(2.*x2r[j])+t1;


                    alpha=x2r[j]/double(x3r[j]);
                    beta=x2r[j];

                    apb=alpha+beta;
                    amb=alpha-beta;

					if( tt>=t1  && tt <=t2  )
					{

	                    te=tt-t1;
	
						arg=x2r[j]*te;  

						w=  x1r[j]*sin(arg/double(x3r[j]))*sin(arg);

	                    v = -(1./apb)*sin(apb*te)+(1./amb)*sin(amb*te);
				        v*= x1r[j]/2.;
                        v*= 386.;

                        d = (1./pow(apb,2.))*(cos(apb*te)-1.);
				        d-= (1./pow(amb,2.))*(cos(amb*te)-1.);
				        d*= x1r[j]/2.;                        
				        d*= 386.;

						vlast[j]=v;

					}



//					printf("%ld %ld tt=%9.4g w=%9.4g t1=%9.4g  t2=%9.4g nhs=%ld freq=%9.4g \n",k,j,tt,w,t1,t2,nhs[j],freq[j]);


					aaa+=w; 

					vvv+=v;

					ddd+=d;


					amp[k]-=w;



					if(x3r[j]<1){break;}



//					if(freq[j]<1){break;}

					
				}

			  fprintf(pFile[2],"\n %14.7e \t %14.7e",t[k],amp[k]);
		      fprintf(pFile[3],"\n %14.7e \t %14.7e",t[k],aaa);
		      fprintf(pFile[4],"\n %14.7e \t %14.7e",t[k],vvv);

		      fprintf(pFile[5],"\n %14.7e \t %14.7e",t[k],ddd);


		}
		fclose(pFile[2]);
		fclose(pFile[3]);
		fclose(pFile[4]);

		fclose(pFile[5]);


//		printf("\n kk=%ld \n",kk);




		printf("\n\n Output Files \n");

		printf("\n  Synthesized Acceleration(G) : accel.out");

		printf("\n              Velocity(in/sec): velox.out");

		printf("\n              Displacement(in): disp.out \n");



		printf("\n\n  Acceleration Error file: error.out \n");



	    printf("\n            Wavelet Table: wavelet_table.out \n\n");



		printf("\n  The wavelet table has five columns:  \n");



		printf("\n  1. index  2. freq(Hz)  3. accel(G)  4. number of half-sines  5. delay(sec) \n");



        printf("\n\n Please call the output files into your own plotting program. \n");

	printf("\n Press any key to exit.\n\n");
	getch();
}

void header(void)
{

	long numBytes=300;



	char string[300];



	int nmax=0;

	long j=1;



	while(fgets(string,numBytes,pFile[1] )>0)
	{

//		printf("%ld.  %s\n",j,string);



		if( strrchr(string,'A' ) != NULL ){nmax=j;}

		if( strrchr(string,'B' ) != NULL ){nmax=j;}

		if( strrchr(string,'C' ) != NULL ){nmax=j;}

		if( strrchr(string,'D' ) != NULL ){nmax=j;}

		if( strrchr(string,'E' ) != NULL && strstr(string,"E+")==NULL && strstr(string,"E-")==NULL ){nmax=j;}

		if( strrchr(string,'F' ) != NULL ){nmax=j;}

		if( strrchr(string,'G' ) != NULL ){nmax=j;}

		if( strrchr(string,'H' ) != NULL ){nmax=j;}

		if( strrchr(string,'I' ) != NULL ){nmax=j;}

		if( strrchr(string,'J' ) != NULL ){nmax=j;}

		if( strrchr(string,'K' ) != NULL ){nmax=j;}

		if( strrchr(string,'L' ) != NULL ){nmax=j;}

		if( strrchr(string,'M' ) != NULL ){nmax=j;}

		if( strrchr(string,'N' ) != NULL ){nmax=j;}

		if( strrchr(string,'O' ) != NULL ){nmax=j;}

		if( strrchr(string,'P' ) != NULL ){nmax=j;}

		if( strrchr(string,'Q' ) != NULL ){nmax=j;}

		if( strrchr(string,'R' ) != NULL ){nmax=j;}

		if( strrchr(string,'S' ) != NULL ){nmax=j;}

		if( strrchr(string,'T' ) != NULL ){nmax=j;}

		if( strrchr(string,'U' ) != NULL ){nmax=j;}

		if( strrchr(string,'V' ) != NULL ){nmax=j;}

		if( strrchr(string,'W' ) != NULL ){nmax=j;}

		if( strrchr(string,'X' ) != NULL ){nmax=j;}

		if( strrchr(string,'Y' ) != NULL ){nmax=j;}

		if( strrchr(string,'Z' ) != NULL ){nmax=j;}

//

		if( strrchr(string,'a' ) != NULL ){nmax=j;}

		if( strrchr(string,'b' ) != NULL ){nmax=j;}

		if( strrchr(string,'c' ) != NULL ){nmax=j;}

		if( strrchr(string,'d' ) != NULL ){nmax=j;}

		if( strrchr(string,'e' ) != NULL  && strstr(string,"e+")==NULL && strstr(string,"e-")==NULL ){nmax=j;}

		if( strrchr(string,'f' ) != NULL ){nmax=j;}

		if( strrchr(string,'g' ) != NULL ){nmax=j;}

		if( strrchr(string,'h' ) != NULL ){nmax=j;}

		if( strrchr(string,'i' ) != NULL ){nmax=j;}

		if( strrchr(string,'j' ) != NULL ){nmax=j;}

		if( strrchr(string,'k' ) != NULL ){nmax=j;}

		if( strrchr(string,'l' ) != NULL ){nmax=j;}

		if( strrchr(string,'m' ) != NULL ){nmax=j;}

		if( strrchr(string,'n' ) != NULL ){nmax=j;}

		if( strrchr(string,'o' ) != NULL ){nmax=j;}

		if( strrchr(string,'p' ) != NULL ){nmax=j;}

		if( strrchr(string,'q' ) != NULL ){nmax=j;}

		if( strrchr(string,'r' ) != NULL ){nmax=j;}

		if( strrchr(string,'s' ) != NULL ){nmax=j;}

		if( strrchr(string,'t' ) != NULL ){nmax=j;}

		if( strrchr(string,'u' ) != NULL ){nmax=j;}

		if( strrchr(string,'v' ) != NULL ){nmax=j;}

		if( strrchr(string,'w' ) != NULL ){nmax=j;}

		if( strrchr(string,'x' ) != NULL ){nmax=j;}

		if( strrchr(string,'y' ) != NULL ){nmax=j;}

		if( strrchr(string,'z' ) != NULL ){nmax=j;}

//

		if( strrchr(string,'!' ) != NULL ){nmax=j;}

		if( strrchr(string,'@' ) != NULL ){nmax=j;}

		if( strrchr(string,'#' ) != NULL ){nmax=j;}

		if( strrchr(string,'$' ) != NULL ){nmax=j;}

		if( strrchr(string,'%' ) != NULL ){nmax=j;}

		if( strrchr(string,'^' ) != NULL ){nmax=j;}

		if( strrchr(string,'&' ) != NULL ){nmax=j;}

		if( strrchr(string,'*' ) != NULL ){nmax=j;}

		if( strrchr(string,'/' ) != NULL ){nmax=j;}

		if( strrchr(string,'>' ) != NULL ){nmax=j;}

		if( strrchr(string,'<' ) != NULL ){nmax=j;}

		if( strrchr(string,'?' ) != NULL ){nmax=j;}

		if( strrchr(string,'=' ) != NULL ){nmax=j;}

		if( strrchr(string,';' ) != NULL ){nmax=j;}



		j++;

	}

	rewind(pFile[1]);



	printf("\n\n %ld header lines detected \n\n",nmax);



	for(j=0;j<nmax;j++)

	{

		fgets(string,numBytes,pFile[1] );

		printf(" %s ",string);

	}

	if(nmax>=1)

	{

		printf("\n");

	}

}

