#include <math.h>

#include <stdio.h>

#include <string.h>

#include <stdlib.h>

#include <conio.h>





#define CORE \
{\
	x[j]=    a1[j]* xb[j]\
			+a2[j]*xbb[j]\
			+b1[j]*y\
			+b2[j]*yb[j];\
 \
	if(x[j] > xmax[j])\
	{\
		xmax[j]=x[j];\
	}\
	if(x[j] < xmin[j])\
	{\
		xmin[j]=x[j];\
	}\
 \
	xbb[j]=xb[j];\
	xb[j]= x[j];\
	yb[j]= y;\
 \
}\





#define NUM_W 1000

#define NUM_SRS 1000



void synthesis2(void);

void synthesis(void);

void enter_data(void);

void qsrs(void);

void qsrs2(void);

void scale_srs(void);

void output(void);

void error(void);



long iflag;



const double max=32767.;





double ratio,srsa;

double c1,c2,len,x;





double em;

double ew;

double emax=1.0e+20;



const double pi=atan2(0.,-1.);

const double tpi=2.*pi;



double grms,ms;



double gbefore;



double dt,dur;

double ssr,tt,t,a;



double rrr[NUM_W];

double rrrold[NUM_W];



double amp[NUM_W],f[NUM_W],td[NUM_W];



double fn[NUM_SRS],srs[NUM_SRS];



double xmin[NUM_SRS],xmax[NUM_SRS];



double accel[1000000];



long last_srs;



long NHS[NUM_W];



long i,j,n,nt,last_wavelet;



long ijk;



long iter;



double damp;



FILE *pFile[15];

char filename[15][FILENAME_MAX];




void main()
{



    printf("\n wavelet_scale_SRS.cpp, ver 1.1, April 19, 2009 \n");

    printf("\n by Tom Irvine, Email: tomirvine@aol.com \n");



	printf("\n This programs scales the individual wavelets of a wavelet series  ");

	printf("\n so that the resulting time history satisfies an SRS specification. \n");



	enter_data();

	

	printf("\n Enter number of iterations \n");

	scanf("%ld",&iter);





//	damp=10.;

//	damp = 1./(2.*damp);

	damp=0.02;

		for(i=0;i<NUM_W;i++)

		{

			rrrold[i]=1.;

			rrr[i]=1.;

		}



	printf("\n");



	for(ijk=0;ijk<50;ijk++)

	{

		synthesis();



        printf(" %ld.  %8.4g \n",ijk,grms);



		if(ijk>10)

		{

			if( fabs((grms-gbefore)/grms) < 0.0005)

			{

				break;

			}

		}



		gbefore = grms;



		iflag=1;

		qsrs();

		scale_srs();

    }

	printf("\n");





	iflag=2;

	qsrs();

    error();



	printf("pre: %ld  %8.4g\n",ijk,emax);


	for(ijk=0;ijk<iter;ijk++)
    {

		synthesis2();		

		iflag=2;

		qsrs();

		error();



//		exit(1);

    }





    printf("\n\n The output text file is: \n\n  %s  \n",filename[3]);



    printf("\n Press any key to exit.\n\n");

    getch();

	

}

void error(void)

{

	em=0.;

	ew=0.;



	for(i=0; i<=last_srs; i++)

	{

		if(xmax[i]<fabs(xmin[i]))

		{

			xmax[i]=fabs(xmin[i]);

		}

    }



	for(i=0; i<=last_srs; i++)

	{

		ew=fabs(20.*log10(xmax[i]/srs[i]));



		if( ew>em)

		{

//			printf(" %ld f=%8.4g  xmax=%8.4g  srs=%12.4g ew=%8.4g\n",i,fn[i],xmax[i],srs[i],ew);

			em=ew;

//			

		}

	}



    

	if(em<emax)

	{

		emax=em;



		printf(" %ld  %8.4g  %8.4g\n",ijk,em,emax);



		

		for(i=0; i<last_wavelet; i++)

		{

				amp[i]*=rrr[i];

        } 

		output();

	}

//	



}

void synthesis(void)

{   

//	printf("\n synthesis \n");

    strcpy(filename[3],"s1.out");
	pFile[3]=fopen(filename[3], "w");



	ms=0.;



	for(j=0; j<nt; j++)
	{

		a=0;

		t=dt*j;





		for(i=0; i<last_wavelet; i++)

		{

			tt=t-td[i];



			if( t>=td[i] && tt <= NHS[i]/(2.*f[i])  )

			{

				a+=amp[i]*sin(tpi*f[i]*tt/double(NHS[i]) )*sin(tpi*f[i]*tt);

			}

		}

		fprintf(pFile[3],"%12.5f \t %12.4f \n",t,a);

	

		accel[j]=a;



		ms+=pow(a,2);

	}

	fclose(pFile[3]);



	grms=sqrt(ms/nt);



}

void synthesis2(void)

{   

//	printf("\n synthesis \n");


//	pFile[3]=fopen(filename[3], "w");



	ms=0.;







	for(i=0; i<last_wavelet; i++)

	{

		rrr[i]=( 0.99 + 0.02*rand()/max);

	}



	for(j=0; j<nt; j++)

	{

		a=0;

		t=dt*j;





		for(i=0; i<last_wavelet; i++)

		{

			tt=t-td[i];



			if( t>=td[i] && tt <= NHS[i]/(2.*f[i])  )

			{

				a+=rrr[i]*amp[i]*sin(tpi*f[i]*tt/double(NHS[i]) )*sin(tpi*f[i]*tt);

			}

		}

//		fprintf(pFile[3],"%12.5f \t %12.4f \n",t,a);

	

		accel[j]=a;



		ms+=pow(a,2);

	}

//	fclose(pFile[3]);



	grms=sqrt(ms/nt);



}

void enter_data(void)

{

	



	printf("\n Enter the sample rate (samples/sec)\n");

	scanf("%lf",&ssr);



	printf("\n\n Enter the duration (sec) \n");

	scanf("%lf",&dur);



	printf("\n\n The SRS must have two columns: fn(Hz) & peak accel(G) " );

	

	printf("\n\n Enter the name of the reference SRS: \n");	              

	scanf("%s",filename[0]);



	printf("\n\n The wavelet table must have four columns:  ");

	printf("\n 1. accel(G)  2. freq(Hz)   3. number of half-sines   4. delay(sec) \n");



	printf("\n\n Enter the filename of the wavelet table. \n");

	scanf("%s",filename[1]);



	for(i=0;i<=1;i++)

	{



		pFile[i]=fopen(filename[i], "rb");



		if(pFile[i] == NULL )

		{

			printf(" Failed to open file: %s \n", filename[i]);

			exit(1);   

		}

		else

		{

			printf(" File: %s opened. \n", filename[i]);

		}



	}





	i=0;



	while( fscanf(pFile[0]," %lf %lf \n",&fn[i],&srs[i]) > 0 )

	{



		printf(" %8.4g  %8.4g \n",fn[i],srs[i]);



		last_srs=i;

		i++;



		if(i==NUM_SRS){break;}

	}



	printf("\n");



//    fscanf(pFile[1],"%ld",&i);



	i=0;



	double a1_freq,a2,a4;

	long i3;

    long inu;

	for(i=0;i<150;i++)
	{
		fscanf(pFile[1],"%ld %lf %lf %ld %lf",&inu,&a1_freq,&a2,&i3,&a4);

		a1_freq*=tpi;


//		printf(" %8.4g  %8.4g  %8.4g \n",a2,fn[0],fn[last_srs] );

	
        if(a1_freq>=tpi*fn[0] && a1_freq<=tpi*fn[last_srs])
		{

			amp[i]=a2;

			  f[i]=a1_freq;

			NHS[i]=i3;

			 td[i]=a4;

			f[i]/=tpi;

			printf("%ld %8.4g %8.4g %ld %8.4g \n",i,amp[i],f[i],NHS[i],td[i]);	

		}

	}



	last_wavelet=i;



//	getch();





	dt=1./ssr;

	nt=long(dur/dt);



	printf("\n last_wavelet= %ld \n",last_wavelet);

	printf("\n nt= %ld \n",nt);

	printf("\n dt= %lf \n",dt);





    printf("\n\n Enter the filename of the output time history. \n");

	scanf("%s",filename[3]);



}

void qsrs(void)

{



	double omega;

	double omegad;

	double cosd;

    double sind;

    double domegadt;

	

	double a1[NUM_SRS],a2[NUM_SRS],b1[NUM_SRS],b2[NUM_SRS];



    double x[NUM_SRS];

    double xb[NUM_SRS];

	double xbb[NUM_SRS];

	double y;

	double yb[NUM_SRS];



	double t;



	double sr=ssr;



	for(i=0; i<NUM_SRS; i++)

	{

			xmax[i]=0.;

			xmin[i]=0.;	

			

			  x[i]=0.;

			 xb[i]=0.;

			xbb[i]=0.;

			 yb[i]=0.;

    }





/********************* intialize frequency array *********************/

   

   while( 1 > 0 )

   {

//     printf("\n\n Enter starting frequency (Hz) \n");

//     scanf("%lf",&fn[0]);



	  if(fn[0] > sr/4.)

	  { 

		  printf("\n\n Starting frequency must be < %lf ", sr/4.);

	  }

	  else

	  {

		  if(fn[0] <= 1.0e-20 )

		  {

			  printf("\n\n Starting frequency must be > 0. ");

		  }

		  else

		  {

			  break;

		  }

	  }



   }

   

   long jnum=last_srs; 



   if(iflag==1)

   {

	   jnum= last_wavelet-1;

   }



/*********************** initialize filter coefficients ***************/

   for(j=0;j<=jnum;++j)

   {

      

		omega=2.*pi*fn[j];



		if(iflag==1)

		{

			omega=2.*pi*f[j];

		}





		omegad=omega*sqrt(1.-pow(damp,2));

		cosd=cos(omegad*dt);

		sind=sin(omegad*dt);

		domegadt=damp*omega*dt;

		a1[j]=2.*exp(-domegadt)*cosd;

		a2[j]=-exp(-2.*domegadt);

		b1[j]=2.*domegadt;

		b2[j]=omega*dt*exp(-domegadt);

		b2[j]*=( (omega/omegad)*(1.-2.*pow(damp,2))*sind -2.*damp*cosd );



/*      fprintf(pFile[2],"\n %g %g %g %g ",a1_freq[j],a2[j],b1[j],b2[j]);  */

   }



/********************** primary response calculation *******************/

      

//   strcpy(filename[3],"atemp.out");

//   pFile[3]=fopen(filename[3],"w");



   for(i=0; i<nt; i++)

   {

		y=accel[i];



//		if(iflag==2)

//		{

//			fprintf(pFile[3],"%12.5f \t %12.4f \n",t,accel[j]);

//		}



		for(j=0; j<=jnum; ++j)

		{               

				CORE    

		}



		t=i*dt;

   }



//   fclose(pFile[3]);

  



/********************** residual response calculation *******************/

   

   long ivk;

   long limit=long(1.2/(dt*fn[0]));

   

   double ff;



   y=0.;



   for(ivk=1; ivk<=limit; ivk++)

   {



		for(j=0; j<=jnum; ++j)

		{



            ff=fn[j];



			if(iflag==1)

			{

				ff=f[j];

			}



			if( dt*ivk > 1.2/ff ){break;}



			CORE

		}

   }



}

void scale_srs(void)

{





	double old;





	for(i=0; i<last_wavelet; i++)

	{



		if(xmax[i]<fabs(xmin[i]))

		{

			xmax[i]=fabs(xmin[i]);

		}

    }



//***************************************



	for(i=0; i<last_wavelet; i++)

	{



		for(j=0;j< (last_srs-1) ;j++)

		{



			if(  f[i]>= fn[j] && f[i]<= fn[j+1]  )

			{



				len=fn[j+1]-fn[j];



				x=f[i]-fn[j];



				c2=x/len;



				c1=1.-c2;



				srsa = c1*srs[j] + c2*srs[j+1];



				ratio = fabs(srsa/xmax[i]);



				old = amp[i];



				amp[i]*=pow(ratio,0.1);



//				printf("%ld f=%8.4g old=%8.4g  amp=%8.4g  ratio=%8.4g  xmax=%8.4g  srsa=%8.4g \n",i,f[i],old,amp[i],ratio,xmax[i],srsa);



				break;

			}

		}

	}

//	getch();

}

void output(void)

{



	double fout[NUM_W];

	double xm[NUM_W];



	long last=last_srs+1;



	if(iflag==1)

	{

		last=last_wavelet;

	}





	pFile[3]=fopen(filename[3], "w");



	for(j=0; j<nt; j++)

	{

		t=dt*j;



		fprintf(pFile[3],"%12.5f \t %12.4f \n",t,accel[j]);



	}

	fclose(pFile[3]);



//*******************************************************



    strcpy(filename[10],"srs.out");

	pFile[10]=fopen(filename[10],"w");



	for(i=0;i<last_wavelet;i++)

	{

		if(xmax[i]< fabs(xmin[i]))

		{

			xmax[i]=fabs(xmin[i]);

		}



//		printf(" %8.4g  %8.4g \n",f[i],xmax[i]);

	}



//    printf("\n");

	double temp;



	for(i=0;i<last;i++)

	{ 

		fout[i]=fn[i];

		if(iflag==1)

		{

		   fout[i]=f[i];

        }



		xm[i]=xmax[i];

	}



	for(i=0;i<last-1;i++)

	{

		if(iflag==1)

		{

		for(j=i+1;j<last;j++)

		{

			if(fout[j]<fout[i])

			{

				temp=fout[j];

				fout[j]=fout[i];

				fout[i]=temp;



				temp=xm[j];

				xm[j]=xm[i];

				xm[i]=temp;

			}

		}

//		printf(" %8.4g  %8.4g \n",f[i],xmax[i]);

        }



   	    fprintf(pFile[10]," %8.4g  %8.4g \n",fout[i],xm[i]);

	}



	fclose(pFile[10]);

}

